library dllRout;

uses  SysUtils,  Classes, Forms, dialogs, Stdctrls, math;

Const n: integer = 25;
Const //xdata: array[0..9] of double =(80.0,140.9,204.7,277.9,356.8,453.0,505.6,674.5,802.32,936.04);
      //ydata: array[0..9] of double =(6.64,11.54,15.89,20.16,21.56,21.69,22.66,23.15,18.16,16.81);
      {ydata: array[0..36] of double = (80.574,84.248,87.264,87.195,89.076,89.608,89.868,90.101,92.405,
                                      95.854,100.696,101.060,401.672,390.724,567.534,635.316,733.054,
                                      759.087,894.206,990.785,1090.109,1080.914,1122.643,1178.351,
                                      1260.531,1273.514,1288.339,1327.543,1353.863,1414.509,1425.208,
                                      1421.384,1442.962,1464.350,1468.705,1447.894,1457.628);
      xdata: array[0..36] of double = (-3.067,-2.981,-2.921,-2.912,-2.840,-2.797,-2.702,-2.699,-2.633,
                                      -2.481,-2.363,-2.322,-1.501,-1.460,-1.274,-1.212,-1.100,-1.046,
                                      -0.915,-0.714,-0.566,-0.545,-0.400,-0.309,-0.109,-0.103,0.010,
                                      0.119,0.377,0.790,0.963,1.006,1.115,1.572,1.841,2.047,2.200);}
     xdata: array[0..24] of double = (0.000,0.833,1.667,2.500,3.333,4.167,5.000,5.833,6.667,7.500,8.333,9.167,10.000,10.830,11.670,12.500,13.330,14.170,15.000,15.830,16.670,17.500,18.330,19.170,20.000);
     ydata: array[0..24] of double = (11.000,12.000,13.000,14.010,15.050,16.290,18.330,22.730,35.010,56.320,87.170,99.080,136.800,102.900,94.640,57.810,39.240,33.470,30.320,30.230,31.040,32.010,33.000,34.000,35.000);



      ParameterNo: integer = 6;
      PopulationSize: integer = 50;
      //TopSize: integer = 20;

var Chromosome, temChromosome: array of array of double;
    BestChromosome, FitChromosome: array of double;
    ParRangeYes: array of boolean;
    ParHigh, parLow: array of double;
    FunctionCall: LongInt;
    TopSize: Integer;

Function Fitness(X: array of double): double;
var i: integer;
    temD, tema: double;
begin
     inc(FunctionCall);
     temD := 0;
     for i := 0 to n - 1 do begin
         tema :=
          //(x[0] + x[1]*xdata[i] + x[2]*sqr(xdata[i]) + x[3]*power(xdata[i],3)) / (1 + x[4]*xdata[i] + x[5]*sqr(xdata[i]) + x[6]*Power(xdata[i],3));
          x[0]*exp(-2.77*sqr((xdata[i]-x[1])/x[2]))+x[3]+x[4]*xdata[i]+x[5]*xdata[i]*xdata[i];
         temD := temD + sqr(ydata[i]-tema);
     end;
     Result := sqrt(temD/n);
end;

{Function Fitness(X: array of double): double;
var i, j: integer;
    temD, temD1: double;
begin
     inc(FunctionCall);
     temD := 0;
     for i := 0 to ParameterNo - 1 do begin
         //temD := temD + 3*(cos(2*x[i])+sin(2*x[i+1]))+sqrt(sqr(x[i+1])+sqr(x[i]));
         temD := temD +sin(x[i]+x[i+1])+sin(2*x[i]*x[i+1]/3);
         temD := temD + (-x[i]*sin(sqrt(abs(x[i]))));
     end;
     Result := temD;
end;}

Function ValueLimit(tv: double; GensID: integer):double;
begin
       if ParRangeYes[GensID] then begin
          if (tv > ParHigh[GensID])or(tv < ParLow[GensID]) then
             tv := ParLow[GensID] + random*(ParHigh[GensID] - ParLow[GensID]);
       end;
       result := tv;
end;

Procedure ComputeY(X: array of double; var Obs_Y, Cal_Y: array of double);
var i: integer;
begin
     for i := 0 to High(Obs_y) do begin
         Obs_Y[i] := ydata[i];
         Cal_Y[i] :=
          //(x[0] + x[1]*xdata[i] + x[2]*sqr(xdata[i]) + x[3]*power(xdata[i],3)) / (1 + x[4]*xdata[i] + x[5]*sqr(xdata[i]) + x[6]*Power(xdata[i],3));
          x[0]*exp(-2.77*sqr((xdata[i]-x[1])/x[2]))+x[3]+x[4]*xdata[i]+x[5]*xdata[i]*xdata[i];
     end;
end;

Procedure SetRange;
var i: integer;
begin
     for i := 0 to ParameterNo - 1 do begin
         ParRangeYes[i] := false;
         ParHigh[i] := 500;//30;
         ParLow[i] := -500;//-30;
     end;
end;

Procedure AssignChromosome;
var i, j: integer;
begin
     SetRange;
     for i := 0 to PopulationSize - 1 do
         for j := 0 to ParameterNo - 1 do
             if ParRangeYes[j] then
                Chromosome[i,j] := ParLow[j] + Random*(ParHigh[j] - ParLow[j])
             else
                Chromosome[i,j] := Random;//10*(2*Random - 1);
end;

procedure QuickSort(var A: array of double; var B: array of integer; iLo, iHi: integer);
var
  Lo, Hi, T1: integer;
  T, Mid:     double;
begin
  Lo  := iLo;
  Hi  := iHi;
  Mid := A[(Lo + Hi) div 2];
  repeat
    while A[Lo] < Mid do
      Inc(Lo);
    while A[Hi] > Mid do
      Dec(Hi);
    if Lo <= Hi then
    begin
      T     := A[Lo];
      T1    := B[Lo];
      A[Lo] := A[Hi];
      B[Lo] := B[Hi];
      A[Hi] := T;
      B[Hi] := T1;
      Inc(Lo);
      Dec(Hi);
    end;
  until Lo > Hi;
  if Hi > iLo then
    QuickSort(A, B, iLo, Hi);
  if Lo < iHi then
    QuickSort(A, B, Lo, iHi);
end;

Procedure RoutFunc(te: Tmemo; var StopRun: boolean; var Obs_y, Cal_y: array of double); StdCall;
var i, j, m, m1, LeadK, LeadK2, LeadK3, ite, k, k1, r1, r2, r3, CheckCount: integer;
    temD, tema: double;
    StartT: TDatetime;
    SortK: array of integer;
    CostFit: array of double;
    MinSSE, CheckSSE: double;
    Mute_Rate, TemC, Cross_Rate: double;
//Const //Mute_Rate = 0.85;
      //Cross_Rate = 0.7;

Procedure OutputResult(te: TMemo; var Obs_Y, Cal_Y: array of double);
var ii: integer;
begin
    ComputeY(BestChromosome, Obs_y, Cal_y);
    with te.Lines do begin
         Clear;
         add('Iteration: ' + inttostr(k));
         add('Function Call: ' + inttostr(FunctionCall));
         add('Time: ' + timetostr(now-startt));
         add('FitNess: ' + Floattostr(MinSSE));
         for ii := 0 to ParameterNo - 1 do
             add('Parameter-' + inttostr(ii+1) + ': ' + Floattostr(BestChromosome[ii]));
    end;
end;

Procedure SwapChro(ChroID: integer; FitN: double);
var ii, jj, kk: integer;
begin
    kk := ChroID;
    for ii := 0 to TopSize - 1 do
        if CostFit[ii] > FitN then begin
           kk := ii;
           break;
        end;

    for jj := 0 to ParameterNo - 1 do
        Chromosome[ChroID,jj] := Chromosome[kk,jj];
    CostFit[ChroID] := CostFit[kk];

    //for jj := 0 to ParameterNo - 1 do
    //    Chromosome[TopSize - 1,jj] := Chromosome[kk,jj];
    //CostFit[TopSize - 1] := CostFit[kk];

    {for ii := TopSize - 1 downto kk - 1 do begin
        for jj := 0 to ParameterNo - 1 do
            Chromosome[ii,jj] := Chromosome[ii - 1,jj];
        CostFit[ii] := CostFit[ii-1];
    end;}
    for jj := 0 to ParameterNo - 1 do
        Chromosome[kk,jj] := FitChromosome[jj];
    CostFit[kk] := FitN;
end;

begin
   FunctionCall := 0;
   Setlength(Chromosome, PopulationSize, ParameterNo);
   Setlength(TemChromosome, PopulationSize, ParameterNo);
   Setlength(ParRangeYes, ParameterNo);
   Setlength(ParHigh, ParameterNo);
   SetLength(parLow, parameterNo);
   Setlength(BestChromosome, ParameterNo);
   Setlength(FitChromosome, ParameterNo);
   Setlength(SortK, PopulationSize);
   Setlength(CostFit, PopulationSize);
   AssignChromosome;
   
   TopSize := 30;//PopulationSize - 10;
   for i := 0 to PopulationSize - 1 do begin
       for j := 0 to ParameterNo - 1 do
           FitChromosome[j] := Chromosome[i, j];
       CostFit[i] := Fitness(FitChromosome);
       SortK[i] := i;
       if i = 0 then begin
          LeadK := 0;
          MinSSE := CostFit[i];
       end
       else begin
           if MinSSE > CostFit[i] then begin
              LeadK := i;
              MinSSE := CostFit[i];
           end;
       end;
   end;
   
   for j := 0 to ParameterNo - 1 do
       BestChromosome[j] := Chromosome[LeadK, j];

   ite := 0; k := 0;  k1 := 0;
   CheckCount := 0;
   StartT := now;

   CheckSSE := MinSSE;

   repeat
      //for i := 0 to PopulationSize - 1 do
      //    Sortk[i] := i;
      QuickSort(CostFit, SortK, 0, PopulationSize - 1);
      for i := 0 to PopulationSize - 1 do
         for j := 0 to ParameterNo - 1 do
            temChromosome[i,j] := Chromosome[SortK[i],j];
      Chromosome := temChromosome;

      for i := TopSize to PopulationSize - 1 do begin
          repeat
             r1 := Random(PopulationSize - TopSize) + TopSize;
          Until r1 <> i;
          repeat
             r2 := Random(PopulationSize - TopSize) + TopSize;
          Until (r2 <> r1)and(r2 <> i);
          repeat
             r3 := Random(PopulationSize - TopSize) + TopSize;
          Until (r3 <> r2)and(r3 <> r1)and(r3 <> i);
          //LeadK := Random(Random(Random(TopSize+2)));
          //LeadK := Random(Random(TopSize+1));
          LeadK := Random(TopSize);
          repeat
              //LeadK2 := Random(Random(Random(TopSize+2)));
              LeadK2 := Random(Random(TopSize+1));
              //LeadK2 := Random(TopSize);
          until LeadK2 <> LeadK;

          for m := 0 to 9 do begin
             Mute_Rate := 0.85;
             Cross_Rate := 0.7;
             for m1 := 0 to 0 do begin
             for j := 0 to ParameterNo - 1 do begin
                 if Random > Cross_Rate then
                    temA := Chromosome[i,j]
                 else
                    //temA := (Chromosome[LeadK2,j] + Chromosome[LeadK,j])/2+ Mute_Rate*(Chromosome[LeadK,j] - Chromosome[r1,j]
                    //     +Chromosome[LeadK2,j] - Chromosome[r2,j])/2;
                    temA := (Chromosome[LeadK,j] + (1 - Mute_Rate)*(BestChromosome[j]-Chromosome[LeadK2,j]))+ Mute_Rate*(Chromosome[LeadK,j] - Chromosome[r1,j]
                         +Chromosome[LeadK2,j] - Chromosome[r2,j]+BestChromosome[j] - Chromosome[r3,j])/3;

                 temA := ValueLimit(temA, j);
                 FitChromosome[j] := temA;
             end;//end j
             temA := Fitness(FitChromosome);
             if temA < CostFit[i] then begin
                CostFit[i] := temA;
                for j := 0 to ParameterNo - 1 do
                    Chromosome[i,j] := FitChromosome[j];
                if temA < CostFit[TopSize - 1] then  begin
                   {for j := 0 to ParameterNo - 1 do
                       Chromosome[i,j] := Chromosome[TopSize-1,j];
                   CostFit[i] := CostFit[TopSize-1];
                   for j := 0 to ParameterNo - 1 do
                       Chromosome[TopSize-1,j] := FitChromosome[j];
                   CostFit[TopSize-1] := temA;}

                   SwapChro(i, temA);
                   //StopRun := true;
                   //exit;
                end;
                if temA < CheckSSE then begin
                   CheckSSE := temA;
                   for j := 0 to ParameterNo - 1 do
                       BestChromosome[j] := FitChromosome[j];
                end;
                //break;
             end;
             end;//m1
          end;//end m
      end;//end i
      
      //Chromosome := temChromosome;
      
      if CheckSSE < MinSSE then begin
         CheckCount := 0;
         MinSSE := CheckSSE;
         CheckSSE := MinSSE;
      end
      else inc(CheckCount);
     temD := 0;

     Application.ProcessMessages;

     if k > (400*k1) then begin
        OutputResult(te, Obs_Y, Cal_Y);
        inc(k1);
     end;
     if StopRun then
        break;
     inc(k);
   until (k > 10000)or(CheckCount > 200);
   
   OutputResult(te, Obs_Y, Cal_Y);
end;

Exports RoutFunc;

begin
Randomize;
end.
