Unit IntegrateUnit;

interface

uses SysUtils, Classes, Math;

Type
   Integer1Array = Array of integer;
   Double1Array = Array of Double;
   Double2Array = Array of Array of Double;
   Double3Array = Array of Array of Array of Double;

Function QGauss_Reg(xdata: Double3Array; PData: Double1Array; FileID, IntID, i_i: integer): Double; //1:Gauss
Function QSIMP_Reg(XData: Double3Array; PData: Double1Array; FileID, IntID, i_i: integer): Double; //2:Simpson
Function QGauss_Fun(PData: Double1Array; IntID: Integer): Double; //3:Gauss
Function QSIMP_Fun(PData: Double1Array; IntID: Integer): Double; //4:Simpson

Implementation

Const
    PointCount:  array[1..7] of integer = (2, 3, 4, 5, 6, 10, 15);
    PointKey  :  array[1..8] of integer = (1, 2, 4, 6, 9, 12, 17, 25);
    //n-Point Formula
    Root:  array[1..24] of double =
        (0.577350269189626,                                        //2
         0.0,               0.774596669241483,                     //3
         0.339981043584856, 0.861136311594053,                     //4
         0.0,               0.538469310105683, 0.906179845938664,  //5
         0.238619186083197, 0.661209386466265, 0.932469514203152,  //6
         0.148874338981631, 0.433395394129247, 0.679409568299024,  //10
         0.865063366688985, 0.973906528517172,
         0.0,               0.201194093997435, 0.394151347077563,  //15
         0.570972172608539, 0.724417731360170, 0.848206583410427,
         0.937273392400706, 0.987992518020485);
    Weight:  array[1..24] of double =
         (1.0,                                                      //2
         0.888888888888889, 0.555555555555556,                     //3
         0.652145154862546, 0.347854845137454,                     //4
         0.568888888888889, 0.478628670499366, 0.236926885056189,  //5
         0.467913934572691, 0.360761573048139, 0.171324492379170,  //6
         0.295524224714753, 0.269266719309996, 0.219086362515982,  //10
         0.149451349150581, 0.066671344308688,
         0.202578241925561, 0.198431485327111, 0.186161000115562,  //16
         0.166269205816994, 0.139570677926154, 0.107159220467172,
         0.070366047488108, 0.030753241996117);

//function QGauss(A, B: Double; N: INTEGER): Double;
Function QGauss_Reg(xdata: Double3Array; PData: Double1Array; FileID, IntID, i_i: integer): Double; //Gauss
var C, D, Sum: Double;//N=2,3,4,5,6,10,15
    found: Boolean;
    i, j, jFirst, jLast, N: Integer;
    A1, B1: Array[0..1] of double;//1*1
    A, B: Double;
    Function FUNC(G_G_G: Double): Double;
    begin
        //result := sin(xdata[fileid,0,i_i])*G_G_G+exp(G_G_G)*G_G_G;//1*2
    end;
begin
    //for i := 0 to 1 do begin//1*3
    //    A1[i] := 0+pdata[0];
    //    B1[i] := 1;
    //end;
    
    A := Min(A1[IntID], B1[IntID]);
    B := Max(A1[IntID], B1[IntID]);
    N := 15;//15㷨
    i := 1;
    repeat
      found := (N = PointCount[i]);
      if not found then Inc(i)
    until found or (i > High(PointCount));

    //****cpc
    //if not found
    //then raise EQuadratureError.Create('GaussLegendre:  ' +
    //           IntToStr(N) + '-point formula not implemented.');

    jFirst := PointKey[i];
    jLast  := PointKey[i+1]-1;
    C := (B - A)/2.0;
    D := (B + A)/2.0;

    Sum := 0.0;
    FOR j := jFirst to jLast do begin
      if Root[j] = 0.0 then Sum := Sum + Weight[j]*Func(D)
      else Sum := Sum + Weight[j]*(Func(Root[j]*C + D) +
                                   Func(-Root[j]*C + D))
    end;

    RESULT := C*SUM;
end; 

Function QSIMP_Reg(xdata: Double3Array; PData: Double1Array; FileID, IntID, i_i: integer): Double; //Simpson
const
    EPS = 0.000001;    JMAX = 20;
var
    i, j : integer;
    OST, OS, ST, S: Double;
    A1, B1: Array[0..1] of double;//2*1
    A, B: Double;

    Function FUNC(G_G_G: Double): Double;
    begin
        //result := sin(xdata[fileid,0,i_i])*G_G_G+exp(G_G_G)*G_G_G;//2*2
    end;

    procedure TRAPZD(A, B: Double;var S1: Double; N:integer);
    var
    J,IT:integer;
    TNM,DEL,X1,SUM: double;
    begin
    If N = 1 Then
    begin
        S1:=0.5 * (B - A) * (FUNC(A) + FUNC(B));
        IT:=1;
    end
    Else
    begin
        IT:=Trunc(exp((N - 2)*Ln(2)));
        TNM:=IT;
        DEL:=(B - A) / TNM;
        X1:=A + 0.5 * DEL;
        Sum:=0;
        For J:=1 To IT do
        begin
            Sum:=Sum + FUNC(X1);
            X1:=X1 + DEL;
        end;
        S1:=0.5 * (S1 + (B - A) * Sum / TNM);
    end;
    end;

begin
    //for i := 0 to 1 do begin//2*3
    //    A1[i] := 0+pdata[0];
    //    B1[i] := 1;
    //end;

    A := Min(A1[IntID], B1[IntID]);
    B := Max(A1[IntID], B1[IntID]);
    OST:=-1E+30;
    OS:=-1E+30;
    For J:=1 To JMAX do
    begin
        TRAPZD(A, B, ST, J);
        S:=(4 * ST - OST) / 3;
        If Abs(S - OS) < EPS * Abs(OS) Then Break;
        OS:=S;
        OST:=ST;
    end;
    Result := S;
end;

Function QGauss_Fun(PData: Double1Array; IntID: Integer): Double; //Gauss
var C, D, Sum: Double;//N=2,3,4,5,6,10,15
    found: Boolean;
    i, j, jFirst, jLast, N: Integer;
    A1, B1: Array[0..1] of double;//3*1
    A, B: Double;
    Function FUNC(G_G_G: Double): Double;
    begin
        //result := sin(PData[0])*G_G_G+exp(G_G_G)*G_G_G;//3*2
    end;
begin
    //for i := 0 to 1 do begin//3*3
    //    A1[i] := 0+pdata[0];
    //    B1[i] := 1;
    //end;
    
    A := Min(A1[IntID], B1[IntID]);
    B := Max(A1[IntID], B1[IntID]);
    N := 15;//15㷨
    i := 1;
    repeat
      found := (N = PointCount[i]);
      if not found then Inc(i)
    until found or (i > High(PointCount));

    //****cpc
    //if not found
    //then raise EQuadratureError.Create('GaussLegendre:  ' +
    //           IntToStr(N) + '-point formula not implemented.');

    jFirst := PointKey[i];
    jLast  := PointKey[i+1]-1;
    C := (B - A)/2.0;
    D := (B + A)/2.0;

    Sum := 0.0;
    FOR j := jFirst to jLast do begin
      if Root[j] = 0.0 then Sum := Sum + Weight[j]*Func(D)
      else Sum := Sum + Weight[j]*(Func(Root[j]*C + D) +
                                   Func(-Root[j]*C + D))
    end;

    RESULT := C*SUM;
end;

Function QSIMP_Fun(PData: Double1Array; IntID: Integer): Double; //Simpson
const
    EPS = 0.000001;    JMAX = 20;
var
    i, j : integer;
    OST, OS, ST, S: Double;
    A1, B1: Array[0..1] of double;//4*1
    A, B: Double;

    Function FUNC(G_G_G: Double): Double;
    begin
        //result := sin(PData[0])*G_G_G+exp(G_G_G)*G_G_G;//4*2
    end;

    procedure TRAPZD(A, B: Double;var S1: Double; N:integer);
    var
    J,IT:integer;
    TNM,DEL,X1,SUM: double;
    begin
    If N = 1 Then
    begin
        S1:=0.5 * (B - A) * (FUNC(A) + FUNC(B));
        IT:=1;
    end
    Else
    begin
        IT:=Trunc(exp((N - 2)*Ln(2)));
        TNM:=IT;
        DEL:=(B - A) / TNM;
        X1:=A + 0.5 * DEL;
        Sum:=0;
        For J:=1 To IT do
        begin
            Sum:=Sum + FUNC(X1);
            X1:=X1 + DEL;
        end;
        S1:=0.5 * (S1 + (B - A) * Sum / TNM);
    end;
    end;

begin
    //for i := 0 to 1 do begin//4*3
    //    A1[i] := 0+pdata[0];
    //    B1[i] := 1;
    //end;

    A := Min(A1[IntID], B1[IntID]);
    B := Max(A1[IntID], B1[IntID]);
    OST:=-1E+30;
    OS:=-1E+30;
    For J:=1 To JMAX do
    begin
        TRAPZD(A, B, ST, J);
        S:=(4 * ST - OST) / 3;
        If Abs(S - OS) < EPS * Abs(OS) Then Break;
        OS:=S;
        OST:=ST;
    end;
    Result := S;
end;

end.
